
#include "Arduino.h"

char inputPin = 48; // entrée ICP5 pour Timer5
uint16_t diviseur[6] = {0,1,8,64,256,1024};
uint8_t clockBits;
uint16_t count;
#define BUF_SIZE 256
volatile uint16_t buf[BUF_SIZE];
volatile uint8_t buf_index;
float clock_period;
                 
void start_capture(uint8_t clock) {
    clockBits = clock;
    buf_index = 0;
    cli();
    TCCR5A = 0; // normal counting
    TCCR5B = (1 << ICES5);
    TIMSK5 = (1 << ICIE5); // input capture interrupt enable interrupt 
    sei();
    TCCR5B |= clockBits;
    clock_period = 1.0/F_CPU*diviseur[clock];
}
                 
ISR(TIMER5_CAPT_vect) {
   TCNT5 = 0;
   buf[buf_index] = ICR5; // input capture register
   buf_index++;
   
}   
                 
void setup() {
  Serial.begin(115200);
  pinMode(inputPin,INPUT);
  pinMode(6,OUTPUT);
  analogWrite(6,128);
  start_capture(1);

}
                 
void loop() {
  int i;
  float m;
  delay(500);
  m = 0.0;
  for (i=0; i<BUF_SIZE; i++)  {
    Serial.println(buf[i]);
    m += buf[i];  
  }
  m /= BUF_SIZE;
  Serial.print("Moyenne = ");
  Serial.println(m);
  Serial.print("Période (ms) = ");
  Serial.println(m*clock_period*1000);

}
                 